' This DEMO is intended to send a SNMP trap from BCL. That is useful if you have to 
' send two SNMP traps from the Barionet at the same time.
' Then the standard SNMP trap from normal Barionet setup can be configured and additionally
' the trap from the BCL application (configurable under " Application Setup").

'************************************************
'Version history
'
'v1.01  - SG 31.12.2018  own IP address in SNMP trap corrected
'v1.02  - SG 17.02.2021  added trap mode
'************************************************


DIM com$(30)
DIM set$
DIM oldstate(9)
DIM ip1,ip2,ip3,ip4,port
DIM state,x,i,time
DIM ipa$(16)
DIM pri_t_ip$(16)
DIM sts$(93)
DIM ownip$(16)
DIM oip1, oip2, oip3, oip4
DIM tm , ttime, o



SYSLOG " start second trap v1.02 "

i=iostate(60000)
IF i=26 THEN
	SYSLOG "Barionet50 discovered, enabled 4 inputs",7
	i=4
	ELSE
		i=8
		SYSLOG "Barionet100 discovered, enabled 8 inputs",7
ENDIF


com$= "STP:512"			
OPEN COM$ as 1					' open setup
READ 1, set$					' read values from setup
Close 1

ip1	= MIDGET(set$, 9, 1)			' 520 remote IP address byte 1
ip2	= MIDGET(set$, 10, 1)			' 521 remote IP address byte 2
ip3	= MIDGET(set$, 11, 1)			' 522 remote IP address byte 3
ip4	= MIDGET(set$, 12, 1)			' 523 remote IP address byte 4
IF ip1=0 THEN END
ipa$	= STR$(ip1)+"."+STR$(ip2)+"."+STR$(ip3)+"."+STR$(ip4)	' complete IP address
'port= MIDGET(set$, 4, 2)
port=162			' 515 remote SNMP port

SYSLOG "Target : "+ipa$+":"+STR$(port)
FOR x = 1 TO i
oldstate(x)=9			' trap after reboot
next x

tm	= MIDGET(set$, 14, 1)
IF tm THEN
	ttime = MIDGET(set$, 15, 1)
	IF ttime>3000 THEN ttime=3000
	IF ttime<100 THEN ttime=100
	TIMER 1,(ttime+(ttime/2))
	ON TIMER1 GOSUB 50
	SYSLOG "Ping test started"
ENDIF


com$= "STP:1"			
OPEN COM$ as 1					' open setup
READ 1, set$					' read values from setup
Close 1

ip1	= MIDGET(set$, 48, 1)			' 48 primary IP address byte 1
ip2	= MIDGET(set$, 49, 1)			' 49 primary IP address byte 2
ip3	= MIDGET(set$, 50, 1)			' 50 primary IP address byte 3
ip4	= MIDGET(set$, 51, 1)			' 51 primary IP address byte 4
IF ip1=0 THEN END
pri_t_ip$	= STR$(ip1)+"."+STR$(ip2)+"."+STR$(ip3)+"."+STR$(ip4)	' complete primary IP address for ping

com$ = "UDP:"+ipa$+":9999"	' local UDP socket to send trap
SYSLOG com$
OPEN com$ as 2

ownip$=SPRINTF$("%1A",1)
oip1=VAL(MID$(ownip$,1,3))
oip2=VAL(MID$(ownip$,5,3))
oip3=VAL(MID$(ownip$,9,3))
oip4=VAL(MID$(ownip$,13,3))


1
If OR(o=0,tm=0) THEN
	FOR x = 1 TO i	
	 state=IOSTATE(200+x)		' check IOstate
	 IF oldstate(x)<>state THEN	' compare for IO state change
		time=_TMR_(0)/10		' take system time and prepare
		GOSUB 10			' go to prepare first part of the SNMP trap
		IF state=1 THEN 		
			SYSLOG "Input "+STR$(200+x)+"= "+STR$(state),9
			ON x GOSUB 21,23,25,27,29,31,33,35	' go to prepare second part of the SNMP string
			ELSE
				SYSLOG "Input "+STR$(200+x)+"= "+STR$(state),9
				ON x GOSUB 22,24,26,28,30,32,34,36		' go to prepare second part of the SNMP string

		ENDIF
		WRITE 2, sts$, 92,ipa$,port	'send SNMP trap
		SYSLOG "Trap sent",9
	ENDIF
	oldstate(x)=state		' copy new state to old state
	DELAY 0
	NEXT x				' go to next IO
ENDIF
GOTO 1				' repeat loop
END




	
10  ' Prepare first SNMP part + time stamp
midset sts$,1,-4,&H305a0201
midset sts$,5,-4,&H00040670
midset sts$,9,-4,&H75626c69
midset sts$,13,-4,&H63a44d06
midset sts$,17,-4,&H0a2b0601
midset sts$,21,-4,&H04018188
midset sts$,25,-4,&H53010140
midset sts$,29,-1,&H04
midset sts$,30,-1,oip1
midset sts$,31,-1,oip2
midset sts$,32,-1,oip3
midset sts$,33,-1,oip4
midset sts$,34,-1,&H02
midset sts$,35,-2,&H0106
midset sts$,37,-4,&H02010143
midset sts$,41,-1,&H04 
midset sts$,42,-4,time
RETURN



21
' prepare Trap for register 201 ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H01018149
midset sts$,67,-4,&H020200c9
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814902
midset sts$,91,-2,&H0101
RETURN


22
' prepare Trap for register 201  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H01018149
midset sts$,67,-4,&H020200c9
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814902
midset sts$,91,-2,&H0100
RETURN


23
' prepare Trap for register 202  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814a
midset sts$,67,-4,&H020200ca
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814a02
midset sts$,91,-2,&H0101
RETURN


24
' prepare Trap for register 202  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814a
midset sts$,67,-4,&H020200ca
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814a02
midset sts$,91,-2,&H0100
RETURN


25
' prepare Trap for register 203 ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814b
midset sts$,67,-4,&H020200cb
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814b02
midset sts$,91,-2,&H0101
RETURN


26
' prepare Trap for register 203  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814b
midset sts$,67,-4,&H020200cb
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814b02
midset sts$,91,-2,&H0100
RETURN


27
' prepare Trap for register 204  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814c
midset sts$,67,-4,&H020200cc
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814c02
midset sts$,91,-2,&H0101
RETURN


28
' prepare Trap for register 204  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814c
midset sts$,67,-4,&H020200cc
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814c02
midset sts$,91,-2,&H0100
RETURN


29
' prepare Trap for register 205  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814d
midset sts$,67,-4,&H020200cd
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814d02
midset sts$,91,-2,&H0101
RETURN


30
' prepare Trap for register 205  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814d
midset sts$,67,-4,&H020200cd
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814d02
midset sts$,91,-2,&H0100
RETURN


31
' prepare Trap for register 206  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814e
midset sts$,67,-4,&H020200ce
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814e02
midset sts$,91,-2,&H0101
RETURN


32
' prepare Trap for register 206  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814e
midset sts$,67,-4,&H020200ce
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814e02
midset sts$,91,-2,&H0100
RETURN


33
' prepare Trap for register 207  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814f
midset sts$,67,-4,&H020200cf
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814f02
midset sts$,91,-2,&H0101
RETURN


34
' prepare Trap for register 207  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H0101814f
midset sts$,67,-4,&H020200cf
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02814f02
midset sts$,91,-2,&H0100
RETURN


35
' prepare Trap for register 208  ON
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H01018150
midset sts$,67,-4,&H020200d0
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02815002
midset sts$,91,-2,&H0101
RETURN


36
' prepare Trap for register 208  OFF
midset sts$,46,-1,&H30
midset sts$,47,-4,&H2d301506
midset sts$,51,-4,&H0f2b0601
midset sts$,55,-4,&H04018188
midset sts$,59,-4,&H53010102
midset sts$,63,-4,&H01018150
midset sts$,67,-4,&H020200d0
midset sts$,71,-4,&H3014060f
midset sts$,75,-4,&H2b060104
midset sts$,79,-4,&H01818853
midset sts$,83,-4,&H01010201
midset sts$,87,-4,&H02815002
midset sts$,91,-2,&H0100
RETURN

50
o=PING(pri_t_ip$,ttime)
'SYSLOG "o="+STR$(o)
RETURN


